#include <stdio.h>
#include <stdlib.h>
#include <conio.h>

#include "fpse.h"

// Today some commands are not implemented
char *str_hlp = { "r <x>       : watch regs (x[0..3] return COPx, else return GPR\n"
                  "b <hexadr>  : set breakpoint at hexadr (if no hexadr break is disabled)\n"
                  "g           : go\n"
                  "s           : step\n"
                  "n           : next\n"
                  "<ENTER>     : repeat last command\n"
                  "u <hexadr>  : unassemble at hexadr (if none PC reg is used)\n"
                  "d <hexadr>  : dump data at hexadr (if none PC reg is used)\n"
                  "p <hexadr>  : print portname at hexadr\n"
                  "w <x,hexadr>: write data of type x at hexadr\n"
                  "h           : display this help\n"
                  "q           : quit debugger\n" };

void run_debug(void)
{
 char  buf[80];
 int   fine=1,ncmd,address;
 int   brkadr = 0,brkp=0;
 char  oldcmd=0,cmd;

 while (fine)
    {
        FPSE_Flags |= VERBOSE | DISASMFLG;
        printf(">");
        gets(buf);
        ncmd = sscanf(buf,"%c %x",&cmd,&address);
        if (!cmd) cmd    = oldcmd;
             else oldcmd = cmd;

        switch (cmd) {
        case 'r':
            watch();
            printf("breakpoint: %sable at %08x\n",(brkp)?"en":"dis",brkadr);
            break;
        case 'g':
            FPSE_Flags &= ~(VERBOSE | DISASMFLG);
            while(!stop)
             {
                if (brkp == 1 && PC == brkadr) break;
                if (update_counter()) Interrupt();
                doInst();
            }
            if (stop) {printf("FATAL ERROR during exe\n"); return; }
            break;
        case 's':
            if (update_counter()) Interrupt();
            doInst();
            if (stop) {printf("FATAL ERROR during exe\n"); return; }
            break;
        case 'b':
            if (ncmd<2)
                {
                    brkp ^= 1;
                    break;
                }
            brkadr=address;
            brkp = 1;
            break;
        case 'h':
            printf("%s",str_hlp);
            break;
        case 'q':
            fine = 0;
            break;
        default:
            printf("unknow command.\n");
            break;
        }

    }
}
