/* gte.c */
/*
	1999 by BERO

	document from:

	http://psx.rules.org
	doomed@c64.org

	not tested BIG_ENDIAN
*/
#include <stdio.h>

#include "gte.h"


typedef INT16 MATRIX[10];

typedef struct {
	INT32 x,y,z;
} LVECTOR;

#ifndef TARGET_BIG_ENDIAN

typedef struct {
	INT16 x,y,z,pad;
} SVECTOR;

typedef struct {
	INT16	x,y;
} VECTOR2D;

typedef struct {
	unsigned char r,g,b,code;
} RGBcd;

#else

typedef struct {
	INT16 y,x,pad,z;
} SVECTOR;

typedef struct {
	INT16	y,x;
} VECTOR2D;

typedef struct {
	unsigned char code,b,g,r;
} RGBcd;

#endif /* BIG_ENDIAN */

typedef struct {
	/* DATA_REGS */
	SVECTOR	v0;
	SVECTOR	v1;
	SVECTOR	v2;
	RGBcd	rgb;
	INT32	otz;
	INT32	ir0;
	LVECTOR	ir;
	VECTOR2D	sxy0;
	VECTOR2D	sxy1;
	VECTOR2D	sxy2;
	VECTOR2D	sxyp;
	INT32	sz0;
	INT32	sz1;
	INT32	sz2;
	INT32	sz3;
	RGBcd	rgb0;
	RGBcd	rgb1;
	RGBcd	rgb2;
	INT32	res1;
	INT32	mac0;
	INT32	mac1;
	INT32	mac2;
	INT32	mac3;
	INT32	irgb;
	INT32	orgb;
	INT32	lzcs;
	INT32	lzcr;

	/* CTRL_REGS */
	MATRIX	rot;
	LVECTOR	tr;
	MATRIX	light;
	LVECTOR	bk;
	MATRIX	color;
	LVECTOR	fc;
	INT32	ofx,ofy;
#ifndef TARGET_BIG_ENDIAN
	INT16	h,h_pad;
	INT16	dqa,dqa_pad;
	INT32	dqb;
	INT16	zsf3,zsf3_pad;
	INT16	zsf4,zsf4_pad;
#else
	INT16	h_pad,h;
	INT16	dqa_pad,dqa;
	INT32	dqb;
	INT16	zsf3_pad,zsf3;
	INT16	zsf4_pad,zsf4;
#endif
	INT32	flag;
} REGS;

#define	VX0	r->v0.x
#define	VY0	r->v0.y
#define	VZ0	r->v0.z
#define	VX1	r->v1.x
#define	VY1	r->v1.y
#define	VZ1	r->v1.z
#define	VX2	r->v2.x
#define	VY2	r->v2.y
#define	VZ2	r->v2.z
#define	RGB	r->rgb
#define	R	r->rgb.r
#define	G	r->rgb.g
#define	B	r->rgb.b
#define	OTZ	r->otz
#define	IR0	r->ir0
#define	IR1	r->ir.x
#define	IR2	r->ir.y
#define	IR3	r->ir.z
#define	SX0	r->sxy0.x
#define	SY0	r->sxy0.y
#define	SX1	r->sxy1.x
#define	SY1	r->sxy1.y
#define	SX2	r->sxy2.x
#define	SY2	r->sxy2.y
#define	SXP	r->sxyp.x
#define	SYP	r->sxyp.y
#define	SXY0	r->sxy0
#define	SXY1	r->sxy1
#define	SXY2	r->sxy2
#define	SZ0	r->sz0
#define	SZ1	r->sz1
#define	SZ2	r->sz2
#define	SZ3	r->sz3
#define	RGB0	r->rgb0
#define	RGB1	r->rgb1
#define	RGB2	r->rgb2
#define	MAC0	r->mac0
#define	MAC1	r->mac1
#define	MAC2	r->mac2
#define	MAC3	r->mac3
#define	IRGB	r->irgb
#define	ORGB	r->orgb
#define	LZCS	r->lzcs
#define	LZCR	r->lzcr

#define	_11	0
#define	_12	1
#define	_13	2
#define	_21	3
#define	_22	4
#define	_23	5
#define	_31	6
#define	_32	7
#define	_33	8

#define	R11	r->rot[_11]
#define	R12	r->rot[_12]
#define	R13	r->rot[_13]
#define	R21	r->rot[_21]
#define	R22	r->rot[_22]
#define	R23	r->rot[_23]
#define	R31	r->rot[_31]
#define	R32	r->rot[_32]
#define	R33	r->rot[_33]
#define	TRX	r->tr.x
#define	TRY	r->tr.y
#define	TRZ	r->tr.z
#define	L11	r->light[_11]
#define	L12	r->light[_12]
#define	L13	r->light[_13]
#define	L21	r->light[_21]
#define	L22	r->light[_22]
#define	L23	r->light[_23]
#define	L31	r->light[_31]
#define	L32	r->light[_32]
#define	L33	r->light[_33]
#define	RBK	r->bk.x
#define	GBK	r->bk.y
#define	BBK	r->bk.z
#define	LR1	r->color[_11]
#define	LR2	r->color[_12]
#define	LR3	r->color[_13]
#define	LG1	r->color[_21]
#define	LG2	r->color[_22]
#define	LG3	r->color[_23]
#define	LB1	r->color[_31]
#define	LB2	r->color[_32]
#define	LB3	r->color[_33]
#define	RFC	r->fc.x
#define	GFC	r->fc.y
#define	BFC	r->fc.z
#define	OFX	(r->ofx>>16)
#define	OFY	(r->ofy>>16)
#define	H	r->h
#define	DQA	r->dqa
#define	DQB	r->dqb
#define	ZSF3	r->zsf3
#define	ZSF4	r->zsf4
#define	FLAG	r->flag

#define	CODE	r->rgb.code
#define	R0	r->rgb0.r
#define	G0	r->rgb0.g
#define	B0	r->rgb0.b
#define	R2	r->rgb2.r
#define	G2	r->rgb2.g
#define	B2	r->rgb2.b
#define	CD2	r->rgb2.code

#define	FIX(a)	((a)>>12)

#define	LIMIT(a,min,max)	if (a<min) a=min; else if (a>max) a=max
/* (a<min)?min:(a>max)?max:a */

#define	DEFFUNC(func)	static void func(REGS *r)

#ifdef __GNUC__
/* GCC specific */
#define	LIM(a,min,max,bit) \
	({int t=a; \
	if (t<min) {t=min;FLAG|=1<<bit; } \
	else if (t>max) {t=max;FLAG|=1<<bit; } \
	else {} t; })
/* endif gcc specific */
#else
#define	LIM(a,min,max,bit) \
	( ((a)<min) ? (FLAG|=(1<<bit),min) : \
	( ((a)>max) ? (FLAG|=(1<<bit),max) : (/*FLAG&=~(1<<bit),*/(a)) ) )
#endif

/* A1,A2,A3,F needs 64bit calculate, so ignore */
#define	Lm_B1(a)	LIM(a,-32768,32767,24)
#define	Lm_B2(a)	LIM(a,-32768,32767,23)
#define	Lm_B3(a)	LIM(a,-32768,32767,22)
#define	Lm_C1(a)	LIM(a,0,255,21)
#define	Lm_C2(a)	LIM(a,0,255,20)
#define	Lm_C3(a)	LIM(a,0,255,19)
#define	Lm_D(a)		LIM(a,0,65535,18)
#define	Lm_G1(a)	LIM(a,-1024,1023,14)
#define	Lm_G2(a)	LIM(a,-1024,1023,13)
#define	Lm_H(a)		LIM(a,0,4096,12)

#define	MAC2RGB()	\
	RGB0 = RGB1; RGB1 = RGB2; \
	R2 = Lm_C2(MAC1); \
	G2 = Lm_C2(MAC2); \
	B2 = Lm_C2(MAC3); \
	CD2 = CODE

#define	MAC2IR()	\
	IR1 = Lm_B1(MAC1); \
	IR2 = Lm_B2(MAC2); \
	IR3 = Lm_B3(MAC3)

DEFFUNC(RTPS)
{
	/* RTPS */
	int x,y,z,rz;
	FLAG = 0;
	SZ0 = SZ1; SZ1=SZ2; SZ2=SZ3;
	SXY0 = SXY1; SXY1=SXY2;
	x = MAC1 = FIX(R11*VX0+R12*VY0+R13*VZ0)+TRX;
	y = MAC2 = FIX(R21*VX0+R22*VY0+R23*VZ0)+TRY;
	z = MAC3 = FIX(R31*VX0+R32*VY0+R33*VZ0)+TRZ;
	MAC2IR();
	SZ3 = Lm_D(z);
	rz = H*4096/z;
	SX2 = Lm_G1( FIX(x*rz)+OFX );
	SY2 = Lm_G2( FIX(y*rz)+OFY );
	MAC0 = DQB + FIX(DQA*rz);
	IR0 = Lm_H(MAC0);
}

DEFFUNC(RTPT)
{
	/* RTPT */
	int x,y,z,rz;
	FLAG = 0;

	SZ0 = SZ3;
	x = FIX(R11*VX0+R12*VY0+R13*VZ0)+TRX;
	y = FIX(R21*VX0+R22*VY0+R23*VZ0)+TRY;
	z = FIX(R31*VX0+R32*VY0+R33*VZ0)+TRZ;
	rz = H*4096/z;
	SX0 = Lm_G1( FIX(x*rz)+OFX );
	SY0 = Lm_G1( FIX(y*rz)+OFY );
	SZ1 = Lm_D( z );
	x = FIX(R11*VX1+R12*VY1+R13*VZ1)+TRX;
	y = FIX(R21*VX1+R22*VY1+R23*VZ1)+TRY;
	z = FIX(R31*VX1+R32*VY1+R33*VZ1)+TRZ;
	rz = H*4096/z;
	SX1 = Lm_G1( FIX(x*rz)+OFX );
	SY1 = Lm_G2( FIX(y*rz)+OFY );
	SZ2 = Lm_D( z );
	x = FIX(R11*VX2+R12*VY2+R13*VZ2)+TRX;
	y = FIX(R21*VX2+R22*VY2+R23*VZ2)+TRY;
	z = FIX(R31*VX2+R32*VY2+R33*VZ2)+TRZ;
	rz = H*4096/z;
	SX2 = Lm_G1( FIX(x*rz)+OFX );
	SY2 = Lm_G2( FIX(y*rz)+OFY );
	SZ3 = Lm_D( z );
}

/* MVMVA functions */

static void mvmva(REGS *r,SVECTOR *v,MATRIX m)
{
	MAC1 = FIX(m[_11]*v->x + m[_12]*v->y + m[_13]*v->z);
	MAC2 = FIX(m[_21]*v->x + m[_22]*v->y + m[_23]*v->z);
	MAC3 = FIX(m[_31]*v->x + m[_31]*v->y + m[_33]*v->z);
	FLAG = 0;
	MAC2IR();
}

static void mvmva_cv(REGS *r,SVECTOR *v,MATRIX m,LVECTOR *cv)
{
	MAC1 = FIX(m[_11]*v->x + m[_12]*v->y + m[_13]*v->z)+cv->x;
	MAC2 = FIX(m[_21]*v->x + m[_22]*v->y + m[_23]*v->z)+cv->y;
	MAC3 = FIX(m[_31]*v->x + m[_31]*v->y + m[_33]*v->z)+cv->z;
	FLAG = 0;
	MAC2IR();
}

static void mvmva_ir(REGS *r,MATRIX m)
{
	MAC1 = FIX(m[_11]*IR1 + m[_12]*IR2 + m[_13]*IR3);
	MAC2 = FIX(m[_21]*IR1 + m[_22]*IR2 + m[_23]*IR3);
	MAC3 = FIX(m[_31]*IR1 + m[_32]*IR2 + m[_33]*IR3);
	FLAG = 0;
	MAC2IR();
}

static void mvmva_cv_ir(REGS *r,MATRIX m,LVECTOR *cv)
{
	MAC1 = FIX(m[_11]*IR1 + m[_12]*IR2 + m[_13]*IR3)+cv->x;
	MAC2 = FIX(m[_21]*IR1 + m[_22]*IR2 + m[_23]*IR3)+cv->y;
	MAC3 = FIX(m[_31]*IR1 + m[_32]*IR2 + m[_33]*IR3)+cv->z;
	FLAG = 0;
	MAC2IR();
}

DEFFUNC(rtv0) { mvmva(r,&r->v0,r->rot); }
DEFFUNC(rtv1) { mvmva(r,&r->v1,r->rot); }
DEFFUNC(rtv2) { mvmva(r,&r->v2,r->rot); }
DEFFUNC(rtir) { mvmva_ir(r,r->rot); }

DEFFUNC(rtv0tr) { mvmva_cv(r,&r->v0,r->rot,&r->tr); }
DEFFUNC(rtv1tr) { mvmva_cv(r,&r->v1,r->rot,&r->tr); }
DEFFUNC(rtv2tr) { mvmva_cv(r,&r->v2,r->rot,&r->tr); }
DEFFUNC(rtirtr) { mvmva_cv_ir(r,r->rot,&r->tr); }

DEFFUNC(rtv0bk) { mvmva_cv(r,&r->v0,r->rot,&r->bk); }
DEFFUNC(rtv1bk) { mvmva_cv(r,&r->v1,r->rot,&r->bk); }
DEFFUNC(rtv2bk) { mvmva_cv(r,&r->v2,r->rot,&r->bk); }
DEFFUNC(rtirbk) { mvmva_cv_ir(r,r->rot,&r->bk); }

DEFFUNC(ll) {
	mvmva(r,&r->v0,r->light);
	IR1 = LIM(MAC1,0,32767,24);
	IR2 = LIM(MAC2,0,32767,23);
	IR3 = LIM(MAC3,0,32767,22);
}

DEFFUNC(llv0) { mvmva(r,&r->v0,r->light); }
DEFFUNC(llv1) { mvmva(r,&r->v1,r->light); }
DEFFUNC(llv2) { mvmva(r,&r->v2,r->light); }
DEFFUNC(llir) { mvmva_ir(r,r->light); }

DEFFUNC(llv0tr) { mvmva_cv(r,&r->v0,r->light,&r->tr); }
DEFFUNC(llv1tr) { mvmva_cv(r,&r->v1,r->light,&r->tr); }
DEFFUNC(llv2tr) { mvmva_cv(r,&r->v2,r->light,&r->tr); }
DEFFUNC(llirtr) { mvmva_cv_ir(r,r->light,&r->tr); }

DEFFUNC(llv0bk) { mvmva_cv(r,&r->v0,r->light,&r->bk); }
DEFFUNC(llv1bk) { mvmva_cv(r,&r->v1,r->light,&r->bk); }
DEFFUNC(llv2bk) { mvmva_cv(r,&r->v2,r->light,&r->bk); }
DEFFUNC(llirbk) { mvmva_cv_ir(r,r->light,&r->bk); }

DEFFUNC(lc) {}

DEFFUNC(lcv0) { mvmva(r,&r->v0,r->color); }
DEFFUNC(lcv1) { mvmva(r,&r->v1,r->color); }
DEFFUNC(lcv2) { mvmva(r,&r->v2,r->color); }
DEFFUNC(lcir) { mvmva_ir(r,r->color); }

DEFFUNC(lcv0tr) { mvmva_cv(r,&r->v0,r->color,&r->tr); }
DEFFUNC(lcv1tr) { mvmva_cv(r,&r->v1,r->color,&r->tr); }
DEFFUNC(lcv2tr) { mvmva_cv(r,&r->v2,r->color,&r->tr); }
DEFFUNC(lcirtr) { mvmva_cv_ir(r,r->color,&r->tr); }

DEFFUNC(lcv0bk) { mvmva_cv(r,&r->v0,r->color,&r->bk); }
DEFFUNC(lcv1bk) { mvmva_cv(r,&r->v1,r->color,&r->bk); }
DEFFUNC(lcv2bk) { mvmva_cv(r,&r->v2,r->color,&r->bk); }
DEFFUNC(lcirbk) { mvmva_cv_ir(r,r->color,&r->bk); }


DEFFUNC(DCPL)
{
	MAC1 = FIX( R*IR1 + IR0*(RFC-R*IR1) );
	MAC2 = FIX( G*IR2 + IR0*(GFC-G*IR2) );
	MAC3 = FIX( B*IR3 + IR0*(BFC-B*IR3) );
	FLAG=0;
	MAC2IR();
	MAC2RGB();
}

DEFFUNC(DCPS)
{
	MAC1 = R + IR0*(RFC-R);
	MAC2 = G + IR0*(GFC-G);
	MAC3 = B + IR0*(BFC-B);
	FLAG = 0;
	MAC2IR();
	MAC2RGB();
}

DEFFUNC(INTPL)
{
	MAC1 = IR1 + IR0*(RFC-IR1);
	MAC2 = IR2 + IR0*(GFC-IR2);
	MAC3 = IR3 + IR0*(BFC-IR3);
	FLAG = 0;
	MAC2IR();
	MAC2RGB();
}

/* SQR */
DEFFUNC(sqr0)
{
	MAC1 = IR1*IR1;
	MAC2 = IR2*IR2;
	MAC3 = IR3*IR3;
	FLAG = 0;
	MAC2IR();
}

DEFFUNC(sqr12)
{
	MAC1 = FIX(IR1*IR1);
	MAC2 = FIX(IR2*IR2);
	MAC3 = FIX(IR3*IR3);
	FLAG = 0;
	MAC2IR();
}

#define	_NCS(n) {\
	int t1,t2,t3; \
	t1 = FIX(L11*VX##n + L12*VY##n + L13*VZ##n); \
	t2 = FIX(L21*VX##n + L22*VY##n + L23*VZ##n); \
	t3 = FIX(L31*VX##n + L32*VY##n + L33*VZ##n); \
	MAC1 = RBK + FIX(LR1*t1 +LR2*t2 + LR3*t3); \
	MAC2 = GBK + FIX(LG1*t1 +LG2*t2 + LG3*t3); \
	MAC3 = BBK + FIX(LB1*t1 +LB2*t2 + LB3*t3); \
	MAC2RGB(); }

#define	_NCDS(n) { \
	int t1,t2,t3,tt1,tt2,tt3; \
	t1 = FIX(L11*VX##n + L12*VY##n + L13*VZ##n); \
	t2 = FIX(L21*VX##n + L22*VY##n + L23*VZ##n); \
	t3 = FIX(L31*VX##n + L32*VY##n + L33*VZ##n); \
	tt1 = RBK + FIX(LR1*t1 +LR2*t2 + LR3*t3); \
	tt2 = GBK + FIX(LG1*t1 +LG2*t2 + LG3*t3); \
	tt3 = BBK + FIX(LB1*t1 +LB2*t2 + LB3*t3); \
	MAC1 = R*tt1 + IR0*(RFC-R*tt1); \
	MAC2 = G*tt2 + IR0*(GFC-G*tt2); \
	MAC3 = B*tt3 + IR0*(BFC-B*tt2); \
	MAC2RGB(); }

#define	_NCCS(n) { \
	int t1,t2,t3,tt1,tt2,tt3; \
	t1 = FIX(L11*VX##n + L12*VY##n + L13*VZ##n); \
	t2 = FIX(L21*VX##n + L22*VY##n + L23*VZ##n); \
	t3 = FIX(L31*VX##n + L32*VY##n + L33*VZ##n); \
	tt1 = RBK + FIX(LR1*t1 +LR2*t2 + LR3*t3); \
	tt2 = GBK + FIX(LG1*t1 +LG2*t2 + LG3*t3); \
	tt3 = BBK + FIX(LB1*t1 +LB2*t2 + LB3*t3); \
	MAC1 = FIX(R*tt1); \
	MAC2 = FIX(G*tt2); \
	MAC3 = FIX(B*tt3); \
	MAC2RGB(); }

DEFFUNC(NCS)
{
	FLAG = 0;
	_NCS(0);
	MAC2IR();
}

DEFFUNC(NCT)
{
	/* NCS for V0,V1,V2 */
	FLAG = 0;
	_NCS(0);
	_NCS(1);
	_NCS(2);
	MAC2IR();
}

DEFFUNC(NCDS)
{
	FLAG = 0;
	_NCDS(0);
	MAC2IR();
}

DEFFUNC(NCDT)
{
	/* NCDS for V0,V1,V2 */
	FLAG = 0;
	_NCDS(0);
	_NCDS(1);
	_NCDS(2);
	MAC2IR();
}

DEFFUNC(DPCT)
{
	MAC0 = R0 + IR0*(RFC-R0);
	MAC1 = G0 + IR0*(RFC-G0);
	MAC2 = B0 + IR0*(RFC-B0);
	FLAG = 0;
	MAC2IR();
	MAC2RGB();
}

DEFFUNC(NCCS)
{
	FLAG = 0;
	_NCCS(0);
	MAC2IR();
}

DEFFUNC(NCCT)
{
	/* NCCS for V0,V1,V2 */
	FLAG = 0;
	_NCCS(0);
	_NCCS(1);
	_NCCS(2);
	MAC2IR();
}

DEFFUNC(CDP)
{
	int t1,t2,t3;
	t1 = RBK + FIX(LR1*IR1 +LR2*IR2 + LR3*IR3);
	t2 = GBK + FIX(LG1*IR1 +LG2*IR2 + LG3*IR3);
	t3 = BBK + FIX(LB1*IR1 +LB2*IR2 + LB3*IR3);
	MAC1 = R*t1 + IR0*(RFC-R*t1);
	MAC2 = R*t2 + IR0*(RFC-R*t2);
	MAC3 = R*t3 + IR0*(RFC-R*t3);
	MAC2IR();
	MAC2RGB();
}

DEFFUNC(CC)
{
	int t1,t2,t3;
	t1 = RBK + FIX(LR1*IR1 +LR2*IR2 + LR3*IR3);
	t2 = GBK + FIX(LG1*IR1 +LG2*IR2 + LG3*IR3);
	t3 = BBK + FIX(LB1*IR1 +LB2*IR2 + LB3*IR3);
	MAC1 = R*t1;
	MAC2 = R*t2;
	MAC3 = R*t3;
	MAC2IR();
	MAC2RGB();
}

DEFFUNC(NCLIP)
{
	/* SX0*SY1+SX1*SY2+SX2*SY0-SX0*SY2-SX1*SY0-SX2*SY1 */
	MAC0 = SX0*(SY1-SY2)+SX1*(SY2-SY0)+SX2*(SY0-SY1);
}

DEFFUNC(AVSZ3)
{
	MAC0 = FIX((SZ1 + SZ2 + SZ3)*ZSF3);
	OTZ = Lm_D(MAC0);
}

DEFFUNC(AVSZ4)
{
	MAC0 = FIX((SZ0 + SZ1 + SZ2 + SZ3)*ZSF4);
	OTZ = Lm_D(MAC0);
}


#define	D1	*(INT32*)&R11
#define	D2	*(INT32*)&R22
#define	D3	*(INT32*)&R33

/* OP */
DEFFUNC(op0)
{
	MAC1 = D2*IR3 - D3*IR2;
	MAC2 = D3*IR2 - D1*IR3;
	MAC3 = D1*IR1 - D2*IR1;
	MAC2IR();
}

DEFFUNC(op12)
{
	MAC1 = FIX(D2*IR3 - D3*IR2);
	MAC2 = FIX(D3*IR2 - D1*IR3);
	MAC3 = FIX(D1*IR1 - D2*IR1);
	MAC2IR();
}

/* GPF */
DEFFUNC(gpf0)
{
	MAC1 = IR0*IR1;
	MAC2 = IR0*IR2;
	MAC3 = IR0*IR3;
	MAC2IR();
	MAC2RGB();
}

DEFFUNC(gpf12)
{
	MAC1 = FIX(IR0*IR1);
	MAC2 = FIX(IR0*IR2);
	MAC3 = FIX(IR0*IR3);
	MAC2IR();
	MAC2RGB();
}

DEFFUNC(gpl0)
{
	MAC1 += IR0*IR1;
	MAC2 += IR0*IR2;
	MAC3 += IR0*IR3;
	MAC2IR();
	MAC2RGB();
}

DEFFUNC(gpl12)
{
	MAC1 += FIX(IR0*IR1);
	MAC2 += FIX(IR0*IR2);
	MAC3 += FIX(IR0*IR3);
	MAC2IR();
	MAC2RGB();
}


typedef struct {
	INT32	opcode;
	void (*func)(REGS *r);
} COP2TBL;

COP2TBL cop2tbl[] = {
	{0x0180001,RTPS},
	{0x0280030,RTPT},
/*	{0x0400012,MVMVA}, */
	{0x0680029,DCPL},
	{0x0780010,DCPS},
	{0x0980011,INTPL},
/*	{0x0a00428,SQR}, */
	{0x0c8041e,NCS},
	{0x0d80420,NCT},
	{0x0e80413,NCDS},
	{0x0f80416,NCDT},
	{0x0f8002a,DPCT},
	{0x108041b,NCCS},
	{0x118043f,NCCT},
	{0x1280414,CDP},
	{0x138041c,CC},
	{0x1400006,NCLIP},
	{0x158002d,AVSZ3},
	{0x168002e,AVSZ4},
/*	{0x170000c,OP},
	{0x190003d,GPF},
	{0x1a0003d,GPL}, */

	{0x0486012,rtv0},
	{0x048e012,rtv1},
	{0x0496012,rtv2},
	{0x049e012,rtir},
/*	{0x041e012,rtir0}, */
	{0x0480012,rtv0tr},
	{0x0488012,rtv1tr},
	{0x0490012,rtv2tr},
	{0x0498012,rtirtr},
	{0x0482012,rtv0bk},
	{0x048a012,rtv1bk},
	{0x0492012,rtv2bk},
	{0x049a012,rtirbk},
	{0x04a6412,ll},
	{0x04a6012,llv0},
	{0x04ae012,llv1},
	{0x04b6012,llv2},
	{0x04be012,llir},
	{0x04a0012,llv0tr},
	{0x04a8012,llv1tr},
	{0x04b0012,llv2tr},
	{0x04b8012,llirtr},
	{0x04a2012,llv0bk},
	{0x04aa012,llv1bk},
	{0x04b2012,llv2bk},
	{0x04ba012,llirbk},
	{0x04da412,lc},
	{0x04c6012,lcv0},
	{0x04ce012,lcv1},
	{0x04d6012,lcv2},
	{0x04de012,lcir},
	{0x04c0012,lcv0tr},
	{0x04c8012,lcv1tr},
	{0x04d0012,lcv2tr},
	{0x04d8012,lcirtr},
	{0x04c2012,lcv0bk},
	{0x04ca012,lcv1bk},
	{0x04d2012,lcv2bk},
	{0x04da012,lcirbk},
	{0x0a80428,sqr12},
	{0x0a00428,sqr0},
	{0x178000c,op12},
	{0x170000c,op0},
	{0x198003d,gpf12},
	{0x190003d,gpf0},
	{0x1a8003d,gpl12},
	{0x1a0003d,gpl0},

	{0,NULL}
};

cop2func cop2funcptr(int code)
{
	COP2TBL *tblp;
	for(tblp=cop2tbl;tblp->opcode;tblp++) {
		if (tblp->opcode==code) {
			return (cop2func)tblp->func;
		}
	}
	printf("unsupport cop2:%x\n",code);

	return NULL;
}


int cop2(int code,UINT32 *r)
{
	cop2func func = cop2funcptr(code);
	if (func) { func(r); return 0;}
	return -1;
}

DEFFUNC(LZCR_read)
{
	int tmp = LZCS,cnt;
	if (tmp<0) tmp=~tmp;
	for(cnt=0;cnt<32 && (tmp&0x80000000)==0;cnt++,tmp>>=1);
	LZCR = tmp;
}

DEFFUNC(ORGB_read)
{
	ORGB = ((IR1>>7)&0x1f) | (((IR2>>7)&0x1f)<<5) | (((IR2>>7)&0x1f)<<10);
}

DEFFUNC(IRGB_write)
{
	int data = IRGB;
	IR1 = (data&31)<<4;
	IR2 = ((data>>5)&31)<<4;
	IR3 = ((data>>10)&31)<<4;
}

DEFFUNC(FLAG_read)
{
	if (FLAG&0x7fffffff) FLAG|=(1<<31); else FLAG&=(1<<31);
}

cop2func cop2readfuncptr(int regno)
{
	switch(regno) {
	case 29: return (cop2func)ORGB_read;
	case 31: return (cop2func)LZCR_read;
	case 31+32: return (cop2func)FLAG_read;
	}
	return NULL;
}

cop2func cop2writefuncptr(int regno)
{
	switch(regno) {
	case 28: return (cop2func)IRGB_write;
	}
	return NULL;
}

void cop2read(int regno,UINT32 *r)
{
	cop2func func=cop2readfuncptr(regno);
	if (func) func(r);
}

void cop2write(int regno,UINT32 *r)
{
	cop2func func=cop2writefuncptr(regno);
	if (func) func(r);
}
