#include <windows.h>
#include <io.h>
#include <memory.h>
#include <fcntl.h>

#include "fpse.h"

static int keybind[2][16] = {
  {
	VK_INSERT,	/* L2 */
	VK_PRIOR,	/* R2 */
	VK_DELETE,	/* L1 */
	VK_NEXT,	/* R1 */
	'V',		/* /\ */
	'Z',		/*  O */
	'X',		/*  X */
	'C',		/* [] */
	VK_TAB,		/* SELECT */
	0,
	0,
	VK_RETURN,	/* START */
	VK_UP,		/* UP */
	VK_RIGHT,	/* RIGHT */
	VK_DOWN,	/* DOWN */
	VK_LEFT		/* LEFT */
 },{
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0
 }
};

// This Function is called when emulator starts
int JOY_Open()
{
// Nothing to do here
 return FPSE_OK;
}

// This Function is called when emulator is closed
void JOY_Close()
{
// Nothing to do here
}

// This function is called when the gamepad should vibrate:
// if (motor != 0) then vibrate(on) else vibrate(off)
void JOY_Vibrate(int motor)
{
}

// Return status of buttons (see joydrv.h)
int JOY_Poll(int n)
{
	int i,ret=0;
	for(i=0;i<16;i++) {
		int keycode = keybind[n][i];
		if (keycode && GetAsyncKeyState(keycode)<0) ret|=(1<<i);
	}
	return ~ret;
}
